Sigma Rules
###########

This documentation page describes the parsing of Sigma rules and working with Sigma objects
resulting from parsed rules.

Parsing
*******

Programatic Construction
************************

Rule Collections
****************

.. autoclass:: sigma.collection.SigmaCollection
   :members:

Rule Object Model
*****************

SigmaRule
=========

.. autoclass:: sigma.rule.SigmaRule
   :members:

SigmaLogSource
==============

.. autoclass:: sigma.rule.SigmaLogSource
   :members:


SigmaDetections
===============

.. autoclass:: sigma.rule.SigmaDetections
   :members:


SigmaDetection
==============

.. autoclass:: sigma.rule.SigmaDetection
   :members:

SigmaDetectionItem
==================

.. autoclass:: sigma.rule.SigmaDetectionItem
   :members:

SigmaRuleTag
==============

.. autoclass:: sigma.rule.SigmaRuleTag
   :members:


SigmaLevel
==============

.. autoclass:: sigma.rule.SigmaLevel
   :members:

SigmaStatus
==============

.. autoclass:: sigma.rule.SigmaStatus
   :members:

Sigma Data Types
*******************

SigmaString
==============

.. autoclass:: sigma.types.SigmaString
   :members:

SigmaNumber
==============

.. autoclass:: sigma.types.SigmaNumber
   :members:

SigmaBool
==============

.. autoclass:: sigma.types.SigmaBool
   :members:


SigmaNull
==============

.. autoclass:: sigma.types.SigmaNull
   :members:

SigmaRegularExpression
======================

.. autoclass:: sigma.types.SigmaRegularExpression
   :members:

SigmaCIDRExpression
=====================

.. autoclass:: sigma.types.SigmaCIDRExpression
   :members:

SigmaCompareExpression
======================

.. autoclass:: sigma.types.SigmaCompareExpression
   :members:

SigmaQueryExpression
====================

.. autoclass:: sigma.types.SigmaQueryExpression
   :members:
